const test = require('tape')
const helpers = require('./helpers')

const AST = require('../src/ast')
const Evaluator = require('../src/evaluator')

test('looks up and injects the function to which a symbol refers', t => {
  t.plan(2)

  const tree = helpers.evaluate('(+ 1 2)')

  t.deepEqual(tree[0].function.constructor, Function)
  t.deepEqual(
    tree[0].function.call(
      this,
      new AST.Number({ value: 4 }),
      new AST.Number({ value: 5 })
    ),
    new AST.Number({ value: 9 })
  )
})
